#! /opt/Guardian/perl/bin/perl

# žץȤΥץ
# Version 7.1 000  GUARDIANWALL V7.1ʹ

# : Ѥϥ͡षƤ
# Τޤ޻ѤȥåץǡȻ˾񤭤ޤ

use FileHandle;
use File::Basename;
use File::Copy;
use File::Path;
use Getopt::Long;
use Jcode;
use Time::Local;
use Net::FTP;
use Mail::Send;
use MIME::Base64;

$ENV{'LC_CTYPE'} = 'C';
umask 022;
my $MGWALLDIR = '/opt/Guardian/Admin';
my $MWCONF = "${MGWALLDIR}/bin/guts_adminconf";

my $ADMINDIR = '/opt/Guardian/Admin';
my $SENDMAIL = "${ADMINDIR}/bin/walloff_mail.php";

# ⡼¦ۥȾ(ŬꤷƤ)
my $REMOTE_HOST 	= 'hostname_or_ipaddress';
my $REMOTE_USER 	= 'username';
my $REMOTE_PASS 	= 'password';
my $REMOTE_ARCDIR 	= "/disk1:/disk2";
my $REMOTE_LOGDIR 	= "/opt/Guardian/WALL/logs";
my $REMOTE_HOST_ID  = 'host_id';

# ¦ۥȾ(ŬꤷƤ)
my $LOCAL_LOGDIR 	= "/var/opt/Guardian/Admin/mail";
my $TMPDIR 			= "/tmp";
my $LOGGER			= "${MGWALLDIR}/wall/bin/mw_logger -f ${MGWALLDIR}/etc/admin/admin.conf";
my @LOGS			= qw(deliver archive screening manager viewer);
# ᡼륢ɥ쥹
my $MAILADDRESS 	= 'root';
# Υ᡼ȯԥɥ쥹
my $headerfrom		= undef;
# Υ᡼륵֥
my $subject 		= "GUARDIANSUITE: ǡžλ";

###
#size()᥽åASCII⡼ɤˤ1
#FTPФμˤäƤ1ˤƲ
my $sz_amode		= 0; 

my $ARCH = `uname`;
chomp $ARCH;
my ($DISKFREE, $SORT);
$DISKFREE		= "/opt/Guardian/local/bin/df -kP";

if ($ARCH eq 'SunOS') {
#	$DISKFREE		= "/usr/bin/df -kl";
	$SORT			= "/usr/bin/sort";
}
else { # Linux
#	$DISKFREE		= "/bin/df -kl";
	$SORT			= "/bin/sort";
}

# ǥ쥯ȥ;͵
my $LOG_YOBI		= 2 * 1024 * 1024; # 2 MB
# ᡼¸ǥ쥯ȥ;͵
my $ARC_YOBI		= 10 * 1024 * 1024; # 10 MB
#my $ARC_YOBI		= 100 * 1024 * 1024; # 100 MB


my $prog = (basename($0))[0]; 
my ($debug, $day, $week, $mail, $from, $quiet, $logonly, $servid);
GetOptions('debug', 	\$debug,
		   'day:i', 	\$day,
		   'week:i', 	\$week,
		   'mail:s', 	\$mail,
		   'fromaddr=s', 	\$from,
		   'quiet', 	\$quiet,
		   'log',		\$logonly,
		   'sid=s',		\$servid,
		   'help', 		\&usage,
		  );
# defaults
if (defined $mail) {
	$MAILADDRESS = $mail if ($mail ne '');
}
if (defined $from) {
	$headerfrom ||= $from;
}
if (defined $servid) {
    $REMOTE_HOST_ID = $servid;
}
if (defined $day) {
	$day ||= 1;
}
if (defined $week) {
	$week ||= 1;
	$day += $week * 7;
}

my @msg;
my ($date1, $date2);

if ($#ARGV == 1) {
	my $arg = shift;
	$date1 = getdate($arg);
	unless (defined $date1) {
		die "invalid arg: $arg\n";
	}
	$arg = shift;
	$date2 = getdate($arg);
	unless (defined $date2) {
		die "invalid arg: $arg\n";
	}
	if ($date1 > $date2) {
		($date1, $date2) = ($date2, $date1);
	}
}
elsif ($#ARGV == 0) {
	my $arg = shift;
	$date2 = getdate($arg);
	unless (defined $date2) {
		die "invalid arg: $arg\n";
	}
}
elsif ($#ARGV == -1) { 
	# դ
	my ($y, $m, $d) = (localtime(time() - 24* 3600))[5, 4, 3];
	$date2 = sprintf("%04d%02d%02d", $y + 1900, $m + 1, $d);
}
else {
	usage();
}

{	# (꿷)ǡޡ褦ȤƤ饨顼
	my ($y, $m, $d) = (localtime(time()))[5, 4, 3];
	my $today = sprintf("%04d%02d%02d", $y + 1900, $m + 1, $d);
	if ($today <= $date2) {
		die "$prog: cannot merge today's (or later) data: $date2\n";
	}
}
unless (defined $date1) {
	$day ||= 1;
	$date1 = datecalc($date2, $day - 1);
	if (!defined $date1 or $date1 > $date2) {
		die "invalid arg: $date2 day=$day\n";
	}
}

if ($debug) {
	if (defined $day) {
		print "DEBUG: day: $day\n";
	}
	if (defined $mail) {
		print "DEBUG: send mail to $MAILADDRESS\n";
	}
	print "DEBUG: Range \"$date1\" - \"$date2\"\n";
}	

#
# եޡѺȥǥ쥯ȥ˰ư
#
my $WK_DIR = "$TMPDIR/xfer.$$";
mkpath($WK_DIR, 0, 0755) or die "$prog: cannot make directory: $WK_DIR\n";
chdir($WK_DIR) or die "$prog: cannot change directory: $WK_DIR\n";
if ($debug) {
	print "DEBUG: tmp dir = $WK_DIR\n";
	print "DEBUG: connect to $REMOTE_HOST...\n";
}
END { ## λ˾ä
	chdir("/tmp");
	if (defined($WK_DIR) and -d $WK_DIR) {
		rmtree($WK_DIR, 0);
	}
}

my ($file_count, $total_size) = (0, 0);
my $ret = merge_log_arc($date1, $date2);

# logging
if ($ret == 0) {
	my $let = "$prog: ǡžǥ顼ȯޤ";
	system($LOGGER, $let);
	push(@msg, $let);
}
else {
	my $let = "$prog: ǡžޤ";
	system($LOGGER, $let);
	push(@msg, $let);
	my $sz = pr_byte($total_size);
	push(@msg, "žե: $file_count,  ž: $sz");
}

exit 0 if (defined($quiet) and $ret);

if (defined $mail) {
	# ᡼
#	send_mail($MAILADDRESS, @msg);
	my $cmd = "${SENDMAIL} ${MAILADDRESS} '${subject}'";
	my $fh;
	if (open($fh, "| ${cmd}")) {
	    print $fh join("\n", @msg);
	    close($fh);
	} else {
	    print STDERR "DEBUG: Mail Send Error.(${MAILADDRESS})\n";
		exit 1;
	}
}
else {
	foreach (@msg) {print "$_\n";}
}
exit 0;

################################################################################
sub merge_log_arc
{
	my $err = 0;
	my $date1 = shift;
	my $date2 = shift;

	#
	# ⡼ȥۥȤ³󤷤ޤ
	#
	my $ftp = Net::FTP->new($REMOTE_HOST, Debug=>$debug);
	unless (defined $ftp) {
		error("Cannot connect $REMOTE_HOST");
		return;
	}
	unless ($ftp->login("$REMOTE_USER", "$REMOTE_PASS") ) {
		error("Cannot connect $REMOTE_HOST");
		return;
	}
	
	my ($fy, $fm, $fd) = unpack('A4 A2 A2', $date1);
	my ($ty, $tm, $td) = unpack('A4 A2 A2', $date2);
	my $localhost = `hostname`;
	chomp $localhost;
	push(@msg, "ۥ: $localhost");
	push(@msg, "⡼ȥۥ: $REMOTE_HOST");
	push(@msg, "žоݴ: $fy/$fm/$fd - $ty/$tm/$td");
	my ($S, $M, $H, $day, $mon, $year) = (localtime())[0 .. 5];
	my $start = sprintf("%04dǯ%02d%02d %02d%02dʬ%02d",
					$year + 1900, $mon + 1, $day, $H, $M, $S);
	push(@msg, "žϻ: $start");

	#
	# žȥޡ
	#
	my ($y, $m, $d, $em, $ed);
	for ($y = $fy; $y <= $ty; $y++) {
		$m = ($y == $fy ? $fm : 1);
		$em = ($y == $ty ? $tm : 12);
		for ( ; $m <= $em; $m++) {
			$d = ($y == $fy && $m == $fm ? $fd : 1);
			$ed = ($y == $ty && $m == $tm ? $td : 31);
			for ( ; $d <= $ed; $d++) {
				$y = sprintf("%04d", $y);
				$m = sprintf("%02d", $m);
				$d = sprintf("%02d", $d);
				if ($debug) {print "DEBUG: try $y/$m/$d\n";}
				foreach my $log (@LOGS) {
					$log =~ s/^\s+//;
					$log =~ s/\s+$//;
					next if ($log eq '');
					if ( -e $d ) {unlink $d;}
					next unless ($ftp->cwd("${REMOTE_LOGDIR}/$log/$y/$m"));
					my $remote_logname = "$REMOTE_LOGDIR/$log/$y/$m/$d";
					my $local_logname  = "$LOCAL_LOGDIR/$log/$y/$m/$d";

					# žեΥĴ٤
					if ($sz_amode) {
						$ftp->ascii;
					} else {
						$ftp->binary;
					}
					my $size = $ftp->size($d);
					if ($debug) {
						if ($size eq '') {
							print "DEBUG: $REMOTE_HOST:$remote_logname ΥǤޤ\n";
						}
					}
					next if ($size <= 0);

					# ¦ΥեΥ
					my $logsize = (stat($local_logname))[7];

					# ȥǥ쥯ȥζĴ٤
					my $wkdirfree = (split(/\s+/, (`$DISKFREE $WK_DIR`)[1]))[3];  # KBǤ
					if ($wkdirfree <= ($logsize + $size) / 1024 + 2) {
						error("ޡ뤿κΰ褬ޤ$WK_DIR FREE=$wkdirfree (KB)");
						$err = 1;
						next;
					}

					# ǥ쥯ȥζΰĴ٤
					my $logdirfree = (split(/\s+/, (`$DISKFREE $LOCAL_LOGDIR/$log`)[1]))[3];
					if ($logdirfree <= ($size + $LOG_YOBI) / 1024 + 2) {
						error("ޡɲä뤿ΰ褬ޤ$LOCAL_LOGDIR/$log FREE=$logdirfree (KB)");
						$err = 1;
						next;
					}

					# եGET
					$ftp->binary;
					unless ( $ftp->get($d) ) {
						error("ǡž˼Ԥޤ$REMOTE_HOST:$remote_logname SIZE=$size");
						$err = 1;
						next;
					}

					# žեΥå
					my $local_sz = (stat($d))[7];
					if ( $size != $local_sz) {
						error("ǡžޤۤʤޤ$REMOTE_HOST:$remote_logname SIZE remote=$size, local=$local_sz");
						$err = 1;
						next;
					}

					# եȥǥ쥯ȥ˺
					if ( -f $local_logname ) {
						# ޡоݥХԡ
						unless (copy("$local_logname", "${d}.old.${log}")) {
							error("եΥԡ˼Ԥޤ $local_logname ${d}.old.${log} ($?) $!");
							$err = 1;
							next;
						}
						# ԡžƤ򥽡Ȥ롣 
						# νʣԤϼ(ܥץȤ򷫤֤¹Ԥ줿ȤΤ)
						`$SORT -u -o "${d}.new.${log}" $local_logname $d`;
						if ($?) {
							error("եΥȤ˼Ԥޤ $SORT -u -o ${d}.new.${log} $local_logname $d");
							$err = 1;
							next;
						}
					} 
					else {
						# ޡоݥʤžƤΤǤ褤
						unless (rename($d, "${d}.new.${log}")) {
							error("եΥ͡˼Ԥޤ $d ${d}.new.${log} ($?) $!");
							$err = 1;
							next;
						}
						# ǥ쥯ȥ̵꤬ϺƤ
						unless (-d "$LOCAL_LOGDIR/$log/$y/$m") {
							unless (mkpath("$LOCAL_LOGDIR/$log/$y/$m", 0, 0755)) {
								error("ǥ쥯ȥκ˼Ԥޤ $LOCAL_LOGDIR/$log/$y/$m ($?) $!");
								$err = 1;
								next;
							}
						}
					}
					# ޡƺեե˥͡ह
					# ʳǤ¦Υޡоݥѹ줿麤Τǡʬ
					# ǡΥޡϤǤޤ
					unless (copy("${d}.new.${log}", "$local_logname")) {
						error("եΥԡ˼Ԥޤ ${d}.new.${log} $local_logname ($?) $!");
						$err = 1;
						next;
					}
					if ($debug) {
						print "DEBUG: got and merged $REMOTE_HOST:$remote_logname >> $local_logname\n";
					}
					$file_count++;
					$total_size += $size;
					chmod 0644, $local_logname;
					push(@msg, "եޡޤ $REMOTE_HOST:$remote_logname >> $local_logname");
				}
			}
		}
	}

	#
	# ¸᡼륢֤ž
	#
	if (! $logonly) {
	  ext: foreach my $arcdir (split(/:/, $REMOTE_ARCDIR)) {
			$arcdir =~ s/^\s+//;
			$arcdir =~ s/\s+$//;
			next if ($arcdir eq '');
			next if (! $ftp->cwd("$arcdir") );
			my @list = $ftp->ls;
			foreach my $file (@list) {
				next if ($file !~ m/^(\d{8}-\w{8}-\w{8})\.mar$/ );
				my $arc_name = $1;
				my $mar_file = $1 . ".mar";
				my $idx_file = $1 . ".index";

				my $date = unpack('A8', $file);
				if ( $date1 <= $date and $date <= $date2 ) {
					# ֥եΥĴ٤
					my $remote_marfile = "$arcdir/$mar_file";
					if ($sz_amode) {
						$ftp->ascii;
					} else {
						$ftp->binary;
					}
					my $mar_size = $ftp->size("$mar_file");
					if ($debug) {
						if ($mar_size eq '') {
							print "DEBUG: $REMOTE_HOST:$remote_marfile ΥǤޤ\n";
						}
					}
					next if ($mar_size eq '');

					# ǥåեΥĴ٤
					my $remote_idxfile = "$arcdir/$idx_file";
					if ($sz_amode) {
						$ftp->ascii;
					} else {
						$ftp->binary;
					}
					my $idx_size = $ftp->size("$idx_file");
					if ($debug) {
						if ($idx_size eq '') {
							print "DEBUG: $REMOTE_HOST:$remote_idxfile ΥǤޤ\n";
						}
					}
					next if ($idx_size eq '');


					## ¸ǥ쥯ȥ˻ΰ׵᤹롣
					## ΰΤǤ¸ǥ쥯ȥơ˰ư롣
					my $req_size = $mar_size + $idx_size + $ARC_YOBI; # ͽ¿׵
					my $STOREDIR = `${MGWALLDIR}/wall/bin/mw_store -f${MGWALLDIR}/etc/admin/admin.conf -a$req_size -n$arc_name`;
					if ( $? ) {
						# ΰ׵˼Ԥ鸽¸ǥ쥯ȥǡ
						$STOREDIR = `${MGWALLDIR}/wall/bin/mw_store -f${MGWALLDIR}/etc/admin/admin.conf -c`;
						if ( $? ) {
							error("ߤ¸ǥ쥯ȥǤޤ");
							$err = 1;
							last ext;
						}
						chomp($STOREDIR);
						if ( $STOREDIR eq '' ) {
							error("ߤ¸ǥ쥯ȥǤޤ");
							$err = 1;
							last ext;
						}

						# ¸ǥ쥯ȥζĴ٤
						my $free = (split(/\s+/, (`$DISKFREE $STOREDIR`)[1]))[3];  # KBǤ
						if ($free <= $req_size / 1024 + 2) {
							my $sz = pr_byte($mar_size + $idx_size);
							error("֥եȥǥåեžΰ褬ޤ$STOREDIR FREE=$free (KB),žͽե: $mar_file $idx_file size=$sz");
							$err = 1;
							next;
						}
					}
					chomp($STOREDIR);
					if ( $STOREDIR eq '' ) {
						error("ߤ¸ǥ쥯ȥǤޤ");
						$err = 1;
						last ext;
					}
					unless (chdir $STOREDIR) {
						error("¸ǥ쥯ȥ˰ưǤޤ$STOREDIR ($?) $!");
						$err = 1;
						last ext;
					}
					if ($debug) {
						my $sz = pr_byte($mar_size);
						print "DEBUG GET mar: $mar_file, size=$sz\n";
						$sz = pr_byte($idx_size);
						print "DEBUG GET index: $idx_file, size=$sz\n";
						print "DEBUG current archive directory: $STOREDIR\n";
					}


					# ֥եGET
					$ftp->binary;
					unless ( $ftp->get($mar_file) ) {
						error("ǡž˼Ԥޤ $REMOTE_HOST:$remote_marfile SIZE=$mar_size");
						$err = 1;
						next;
					}
					# ž֥եΥå
					my $local_sz = (stat($mar_file))[7];
					if ($mar_size != $local_sz) {
						error("ǡžޤۤʤޤ$REMOTE_HOST:$remote_marfile SIZE remote=$mar_size, local=$local_sz");
						$err = 1;
						next;
					}
					if ($debug) {
						print "DEBUG: got $REMOTE_HOST:$remote_marfile => $STOREDIR/$mar_file size=$mar_size\n";
					}
					chmod 0644, $mar_file;

					# ǥåեGET
					$ftp->binary;
					unless ( $ftp->get($idx_file) ) {
						error("ǡž˼Ԥޤ $REMOTE_HOST:$remote_idxfile SIZE=$idx_size");
						$err = 1;
						next;
					}
					# žǥåեΥå
					$local_sz = (stat($idx_file))[7];
					if ($idx_size != $local_sz) {
						error("ǡžޤۤʤޤ$REMOTE_HOST:$remote_idxfile SIZE remote=$idx_size, local=$local_sz");
						$err = 1;
						next;
					}
					if ($debug) {
						print "DEBUG: got $REMOTE_HOST:$remote_idxfile => $STOREDIR/$idx_file size=$idx_size\n";
					}
					chmod 0644, $idx_file;

					$file_count++;
					$total_size += $mar_size;
					push(@msg, "֥եžޤ$REMOTE_HOST:$remote_marfile => $STOREDIR/$mar_file");
					$file_count++;
					$total_size += $idx_size;
					push(@msg, "ǥåեžޤ$REMOTE_HOST:$remote_idxfile => $STOREDIR/$idx_file");
				}
			}
		}
	}
	$ftp->quit;

	($S, $M, $H, $day, $mon, $year) = (localtime())[0 .. 5];
	my $finish = sprintf("%04dǯ%02d%02d %02d%02dʬ%02d",
					$year + 1900, $mon + 1, $day, $H, $M, $S);
	push(@msg, "žλ: $finish");

	return if ($err);

    # timestamp.logեι
    udtMGTimeStamp($REMOTE_HOST_ID, $date2, $logonly);

	return 1;
}


sub datecheck
{
	my $arg = shift;
	my ($y, $m, $d) = unpack('A4 A2 A2', $arg);
	my $ltim;
	eval {
		$ltim = timelocal(0,0,0, $d, $m -1, $y - 1900);
	};
	return unless (defined $ltim);
	return 1;
}


sub datecalc
{
	my $date = shift;
	my $diff = shift;
	my $ltime;
	my $ret;

	my ($y, $m, $d) = unpack('A4 A2 A2', $date);
	eval {
		$ltime = timelocal(0, 0, 0, $d, $m -1, $y -1900);
	};
	return unless (defined $ltime);

	$ltime -= 24 * 3600 * $diff;
	return undef if ($ltime < 0);
	($y, $m, $d) = (localtime($ltime))[5, 4, 3];

	return sprintf("%04d%02d%02d", $y + 1900, $m + 1, $d);
}


sub getdate
{
	my $arg = shift;
	my $y = (localtime(time() - 24* 3600))[5] + 1900;
	my $date;

	if ($arg =~ m/^\d{4}$/ ) { 					# MMDD
		$date = sprintf("%04d", $y) . $arg;
	}
	elsif ($arg =~ m/^\d{6}$/ ) {				# YYMMDD
		$date = '20' . $arg;
	}
	elsif ($arg =~ m/^\d{8}$/ ) {				# YYYYMMDD
		$date = $arg;
	}
	elsif ($arg =~ m/^\d{2}[\-\/]\d{2}$/) {		# MM/DD or MM-DD
		$date = sprintf("%04d", $y) . join('', unpack('A2 x1 A2', $arg));
	}
	elsif ($arg =~ m/^\d{2}[\-\/]\d{2}[\-\/]\d{2}$/) {	# YY/MM/DD or YY-MM-DD
		$date = '20' . join('', unpack('A2 x1 A2 x1 A2', $arg));
	}
	elsif ($arg =~ m/^\d{4}[\-\/]\d{2}[\-\/]\d{2}$/) {  # YYYY/MM/DD or YYYY-MM-DD
		$date = join('', unpack('A4 x1 A2 x1 A2', $arg));
	}
 	if (datecheck($date)) {
		return $date;
	}
	return;
}


sub usage
{
	print STDERR "Usage: $prog [OPTIONS] -- [YMD1 [YMD2]]\n";
	print STDERR " options:\n";
	print STDERR " -help: print this message\n";
	print STDERR " -day=N: last N day(s) default=1\n";
	print STDERR " -week=N: last N week(s)\n";
	print STDERR " -mail=addr: send mail to addr (default addr: 'root')\n";
	exit 1;
}


sub error
{
	my $msg = shift;

	push(@msg, "$msg");
	print STDERR "$prog: $msg\n";
}


sub pr_byte
{
	my $byte = shift;

	if ($byte eq '') {
		return "";
	}
	if ($byte >= 1024) {
		$byte /= 1024;
		if ($byte >= 1024) {
			$byte /= 1024;
			$byte = sprintf("%.2fMB", $byte);
		} 
		else {
			$byte = sprintf("%.2fKB", $byte);
		}
	}
	else {
		$byte .= "byte";
	}
	return $byte;
}


sub send_mail
{
	my $address = shift;
	my @status = @_;

	my $msg = new Mail::Send;
	unless (defined $msg) {
		system($LOGGER, "$prog: cannot send message ($?) $!");
		return;
	}
	if ($headerfrom ne '') {
		$msg->set('From', $headerfrom);
	}
	$msg->set('MIME-Version', '1.0');
	$msg->set('Content-Type', 'text/plain; charset=iso-2022-jp');
	$msg->set('Content-Transfer-Encoding', '7bit');
	if ($subject ne '') {
		$subject = jcode($subject)->mime_encode("\n", 66);
		$msg->subject($subject);
	}
	foreach (split(/,/, $address)) {
		s/^\s+//;
		s/\s+$//;
		$msg->add('To', $_);
	}

	my $sm_opt = '';
	my $msp = `$MWCONF -l -sSMTP -kMailSubmissionProgram`;
	chomp $msp;
	$msp =~ s/^\s*\d*\s*:\s*//;
	if ($msp eq 'postfix') {
		$msp = 'sendmail';
	}
	else { 
		$sm_opt = `$MWCONF -l -sSMTP -kSendmailOption`;
		chomp $sm_opt;
		$sm_opt =~ s/^\s*\d*\s*:\s*//;
		$sm_opt =~ s/^\s*//;
		$sm_opt =~ s/\s*$//;
	}
	my $fh;
	if ($sm_opt ne '') {
		$fh = $msg->open($msp, $sm_opt);
	} else {
		$fh = $msg->open($msp);
	}
	unless (defined $fh) {
		system($LOGGER "$prog: cannot send message ($?) $!");
		return;
	}
	foreach (@status) {
		chomp;
		$_ = Jcode::convert($_, 'jis');
		print $fh "$_\n";
	}
	$fh->close();
	return 1;
}

sub udtMGTimeStamp
{
    my ($rid, $ddy, $olg)  = @_;
    my %LogType = ( 'DeliverLog'   => 0,
                    'ArchiveLog'   => 0,
                    'ScreeningLog' => 0,
                    'ManagerLog'   => 0,
                    'ViewerLog'    => 0,
                    'ArchiveData'  => $olg );
    my $ltime;

    my ($y, $m, $d) = unpack('A4 A2 A2', $ddy);
    eval {
        $ltime = timelocal(59, 59, 23, $d, $m -1, $y -1900);
    };
    return unless (defined $ltime);

    my $srvdir = $ADMINDIR . '/etc/admin/server/' . $rid;
    return unless (-d $srvdir);

    my ($cnt, $ResGatN, $isR) = (0, 5, undef);
    for (; $cnt <= (${ResGatN}+1); $cnt++) {
        my $file = $srvdir . '/';
        if ($cnt <= $ResGatN) {
            $file .= 'result_gat.log';
            $file .= '.' . $cnt if ($cnt > 0);
        } else {
            $file .= 'timestamp.log';
        }
        open (RFL, $file) or next;
        $isR = 1;
        last;
    }

    my $file = $srvdir . '/result_gat.log.new';
    unless (open (WFL, ">${file}")) {
        close RFL if (defined($isR));
        return;
    }
    if (defined($isR)) {
        RDLOP: while (<RFL>) {
            my $line = $_;
            chomp $line;
            $line =~ tr/\t//s;         # ;פTAB
            $line =~ s/#.*//g;         # ΥȺ
            $line =~ s/^\s+|\s+$//g;   # ƬΥڡʸ
            next if ($line =~ /^#|^$/);# ȹԡԤ򥹥å

            my ($key, $val) = split(/=/, $line, 2);
            $key =~ s/^\s+|\s+$//g;
            $val =~ s/^\s+|\s+$//g;
            foreach my $logtype (keys(%LogType)) {
                next if ($LogType{$logtype});
                next unless ($logtype eq $key);

                if ($ltime > $val) {
                    print WFL "$logtype = $ltime\n";
                } else {
                    print WFL $_;
                }
                $LogType{$logtype} = 1;
                next RDLOP;
            }
        }
        close RFL;
    }
    foreach my $logtype (keys(%LogType)) {
        print WFL "$logtype = $ltime\n" unless($LogType{$logtype});
    }
    close WFL;

    for ($cnt = (${ResGatN}-1); $cnt >= -1; $cnt--) {
        my $sfl = $srvdir . '/result_gat.log';
        my $dfl = $srvdir . '/result_gat.log';
        if ($cnt > 0) {
            $sfl .= '.' . $cnt;
            $dfl .= '.' . ($cnt+1);
        } elsif ($cnt == 0) {
            $dfl .= '.' . ($cnt+1);
        } else {
            $sfl .= '.new';
        }
        next unless (-f ${sfl});

        if (copy(${sfl}, ${dfl})) {
            chown 0, 0, ${dfl};
            chmod 0644, ${dfl};
            unlink ${sfl};
        }
    }
    unlink ${file} if (-f ${file});

    return 1;
}
__END__
